/*
 * MUSTERLOESUNG FUER DAS GEHEIMNIS DER IRREN BUSFAHRER. TEIL 2
 * ------------------------------------------------------------
 * Apfelmnnchen - mit Farben
 *
 * Version 2.2, 08.03.2002
 */

import  java.awt.*;
import  java.applet.*;

public class Apfel2
  extends Applet
  implements Runnable /* das msst Ihr nicht verstehen */
{

  /* Die Grsse des Applet-Fensters. */
  final int FENSTERMAX_I = 800;
  final int FENSTERMAX_J = 800;

  /* Eigentlich msste man bis in alle Ewigkeit im Bus sitzen bleiben,
     um zu testen, ob er wirklich fr immer und ewig in der Stadt bleibt.
     Mit etwas Vertrauen reicht es aber aus, die ersten paar Stationen
     mitzufahren und zu sehen, ob er nicht heimlich abhaut. MAXITER gibt
     an, wieviele Stationen wir mitfahren. */
  final int MAXITER = 100;

  /* Das sind die Eckpunkte unseres Stadtplans. */
  final double XMIN = -2.2, XMAX = 2.2, YMIN = -2.2, YMAX = 2.2;
  /* Hier die Zoom-Bereiche von den andern 2 Ausschnitten in der Stunde */
//  final double XMIN = -0.12, XMAX = -0.08, YMIN = 0.93, YMAX = 0.97;
//  final double XMIN = -0.101, XMAX = -0.099, YMIN = 0.949, YMAX = 0.951;


  /* hauptProgramm ************************************************************
     Hier wird zuerst die Stadtgrenze gezeichnet (Kreis).
     Anschliessend wird der Stadtplan mit den Mandelbus-Startpunkten gezeichnet
   */

  public void hauptProgramm(Graphics bildschirm) {

    /* Fr jeden Punkt auf dem Bildschirm mchten wir wissen, ob sich seine entsprechende
       Stadtplan-Koordinate als Startpunkt fr die Mandelbusse eignet. */

    double x; /* x-Koordinate im Stadtplan */
    double y; /* y-Koordinate im Stadtplan */
    for (int i = 0; i <= FENSTERMAX_I; i++) {
      for (int j = 0; j <= FENSTERMAX_J; j++) {
        /* Wir wollen fr jeden Bildschirmpunkt (i,j) wissen, wo er im Stadtplan
         * liegt.
         */
        x = berechneStadtplanX(i);
        y = berechneStadtplanY(j);
        /* bleibt der Bus in der Stadt? */
        int fahrstrecke = berechneFahrstrecke (x, y, bildschirm);
        waehleFarbe(fahrstrecke, bildschirm);
        bildschirm.drawLine (i, j, i, j);
      } // for j
      /* Es reicht, wenn wir nach jeder Spalte den Bereich neu zeichnen */
      repaint();
    } // for i

  } // hauptProgramm()


  /* *********************** Eigene Methoden ******************* */

  /* waehleFarbe ****************************************************
     Setzt die Farbe entsprechend der Anzahl Iterationen, die ein Mandel-
     Bus gebraucht hat, um die Stadt zu verlassen. Ist die Anzahl der
     Iterationen gleich MAXITER, dann wird schwarz gezeichnet. */
  void waehleFarbe(int anzahl, Graphics zeichnungsBrett) {
    Color col = new Color(0,0,0); // schwarz wenn MAXITER Iterationen
    if (anzahl<MAXITER) {
      double streckFaktor = 20.0;
      // Wir mchten nun einen Regenbogen-Verlauf erstellen. Von rot nach gelb,
      // dann grn, trkis, blau, violett und wieder zu rot.
      // Die Anzahl der Iterationen um einen Streckfaktor vergrssert und dann
      // Modulo 1536 gerechnet. Modulo 1536 gibt den Rest beim Teilen durch 1536,
      // ergibt also immer Zahlen zwischen 0 und 1535.
      int farbZahl = ((int)(streckFaktor*anzahl))%1536; // Soll nur von 0 bis 1535 gehen
      if (farbZahl>=0 && farbZahl<256) {
        col = new Color(255,farbZahl,0); // bergang rot-gelb
      }
      if (farbZahl>=256 && farbZahl<512) {
        col = new Color(255-(farbZahl-255),255,0); // bergang gelb-grn
      }
      if (farbZahl>=512 && farbZahl<768) {
        col = new Color(0,255,(farbZahl-512)); // bergang grn-zyan
      }
      if (farbZahl>=768 && farbZahl<1024) {
        col = new Color(0,255-(farbZahl-768),255); // bergang zyan-blau
      }
      if (farbZahl>=1024 && farbZahl<1280) {
        col = new Color((farbZahl-1024),0,255); // bergang blau-magenta
      }
      if (farbZahl>=1280 && farbZahl<1536) {
        col = new Color(255,0,255-(farbZahl-1280)); // bergang magenta-rot
      }
    }
    zeichnungsBrett.setColor(col);
  }

  /* berechneFahrstrecke ****************************************************
     Hier wird die Fahrstrecke berechnet. Solange der Bus die Stadt
     nicht verlsst, wird die Position der nchsten Station auf der
     irren Fahrt berechnet.
     Der Rckgabewert ist die Anzahl bedienter Busstationen: Er kann gleich
     der Konstanten MAXITER sein. In diesem Fall ist der Bus innerhalb der
     Stadtgrenze geblieben. Oder aber der Rckgabewert ist eine Zahl kleiner
     als MAXITER. In diesem Fall hat der Bus nach entsprechend
     vielen Halten die Stadt verlassen. */

  int berechneFahrstrecke (double a, double b, Graphics bildschirm) {
    double x = a;
    double y = b;
    int i = 0;  /* Anzahl Bushaltestellen, die man besucht hat */
    double xnew;
    double ynew;
    /* Neue Haltestellen berechnen, solange der Bus innerhalb
       der Stadtgrenze (Kreis: mit Radius 2, also x*x + y*y <= 4)
       ist. Nach Anzahl MAXITER hat man Vertrauen in den Busfahrer
       und bricht die Reise ebenfalls ab. */
    while ( ((x*x + y*y) <= 4) && (i < MAXITER) ) {
      /* Position der nchsten Bushaltestelle berechnen.
         Die Formel steht in der Anleitung. */
      xnew = x*x - y*y + a;
      ynew = 2*x*y + b;

      /* Wir wollen jetzt die einzelnen Bushaltestellen nicht mehr einzeichnen */

      /* Der Bus fhrt weiter. Die neue Haltestelle wird zur aktuellen. */
      x = xnew;
      y = ynew;
      i++;
    }
    /* Die Anzahl Haltestellen, die man mitgefahren ist (i), wird
       an die aufrufende Methode hauptProgramm zurckgegeben. */
    return  i;
  }  /* Ende von berechneFahrstrecke */


  /* ******** Methoden fr die Bildschirmdarstellung ************ */

  /* zeichneFahrstrecke ********************************************
     Die Busstrecke wird im Stadtplan eingezeichnet. Die Position der aktuellen
     und der letzten Haltestelle bekommt man als Parameter. Die Koordinaten
     der Haltestellen werden nun in Bildschirmkoordinaten umgerechnet.  */

  void zeichneFahrstrecke (double x, double y, double xnew, double ynew, Graphics bildschirm) {
    int bildschirmI, bildschirmJ;
    int bildschirmInew, bildschirmJnew;

    /* Bildschirmkoordinaten fr die beiden Bushaltestellen berechnen. */
    bildschirmI    = berechneBildschirmI (x);
    bildschirmInew = berechneBildschirmI (xnew);
    bildschirmJ    = berechneBildschirmJ (y);
    bildschirmJnew = berechneBildschirmJ (ynew);

    /* Linie der Fahrstrecke zeichnen: Von der letzten Haltestelle zur neuen Haltestelle. */
    bildschirm.drawLine (bildschirmI, bildschirmJ, bildschirmInew, bildschirmJnew);
  } /* Ende von zeichneFahrstrecke */


  /* zeichneStadtgrenze ***********************************************
     Diese Methode berechnet die Koordinaten fr die Stadtgrenze
     und zeichnet sie. Die Position und Grsse des Kreises werden definiert,
     indem ein Quadrat um den Kreis herum festgelegt wird. Dazu werden
     der obere linke Eckpunkt, die Breite und Hhe angegeben. */

  void zeichneStadtgrenze (Graphics bildschirm) {
    int linksObenI, linksObenJ;
    int rechtsUntenI, rechtsUntenJ;
    int breite, hoehe;

    linksObenI   = (int)berechneBildschirmI (-2.0);
    linksObenJ   = (int)berechneBildschirmJ (2.0);
    rechtsUntenI = (int)berechneBildschirmI (2.0);
    rechtsUntenJ = (int)berechneBildschirmJ (-2.0);
    breite       = rechtsUntenI - linksObenI;
    hoehe        = rechtsUntenJ - linksObenJ;

    /* Der Kreis wird im Graphikfenster gezeichnet. */
    bildschirm.drawOval (linksObenI, linksObenJ, breite, hoehe);
  } /* Ende von zeichneStadtgrenze */


  /* berechneBildschirmI / berechneBildschirmJ *****************************************************
     Die Koordinaten des Stadtplans (von XMIN bis XMAX und
     von YMIN bis YMAX) mssen in Bildschirmkoordinaten (I,J) umgerechnet werden.
     Zuerst werden die Koordinaten vom linken Stadtplanrand gemessen (statt
     vom Nullpunkt aus: x-XMIN). Die Division durch die Stadtplanbreite
     (XMAX-XMIN) ergibt den "prozentualen" Abstand vom linken Stadtplanrand.
     Dieser Wert wird mit der Fensterbreite multipliziert, um den Abstand
     vom linken Fensterrand zu berechnen.

     Die Umrechnung in J-Richtung ist analog.
     Achtung: Bei den Bildschirmkoordinaten in j-Richtung ist der Nullpunkt
     oben! Zunehmende j-Werte wachsen nach unten, also gerade umgekehrt als
     wie man es sich gewohnt ist.*/

  int berechneBildschirmI (double x) {
    double bildschirmI;
    bildschirmI = ((x-XMIN) / (XMAX-XMIN)) * FENSTERMAX_I ;
     /* Es knnen nur Punkte (und Linien) mit Integer-Koordinaten gezeichnet weden.
       Alle double Zahlen werden deshalb auf Integer abgebildet. */
    return (int) bildschirmI;
  } /* Ende von berechneBildschirmI */

  int berechneBildschirmJ (double y) {
    double bildschirmJ;
    bildschirmJ = FENSTERMAX_J - (((y-YMIN) / (YMAX-YMIN)) * FENSTERMAX_J );
     /* Es knnen nur Punkte (und Linien) mit Integer-Koordinaten gezeichnet weden.
       Alle double Zahlen werden deshalb auf Integer abgebildet. */
    return (int) bildschirmJ;
  }  /* Ende von berechneBildschirmJ */


  /* berechneStadtplanX / berechneStadtplanY *****************************************************
     Die Koordinaten des Bildschirmes (X,Y) mssen in Stadtplan-Koordinaten (I,J)
     umgerechnet werden.
     Wenn wir die Zahl i durch die Konstante FENSTERMAX_I teilen, haben wir den
     "prozentualen" Anteil. Multipliziert mit (XMAX-XMIN) ergibt das den Abstand
     vom linken Stadtrand. Wenn wir also XMIN addieren, haben wir die Stadtplan-
     koordinate.

     Die Umrechnung in Y-Richtung ist analog.
     Achtung: Bei den Bildschirmkoordinaten in j-Richtung ist der Nullpunkt
     oben! Zunehmende j-Werte wachsen nach unten, also gerade umgekehrt als
     wie man es sich gewohnt ist.*/

  double berechneStadtplanX (int i) {
    double stadtplanX;
     /* Da die Stadtplanwerte nicht nur ganze Zahlen sind, muss dafr gesorgt
        werden, dass Java mit double Zahlen rechnet.*/
    stadtplanX = ( ((double)i / FENSTERMAX_I) * (XMAX-XMIN) ) + XMIN;
    return stadtplanX;
  } /* Ende von berechneBildschirmI */

  double berechneStadtplanY (int j) {
    double stadtplanY;
     /* Da die Stadtplanwerte nicht nur ganze Zahlen sind, muss dafr gesorgt
        werden, dass Java mit double Zahlen rechnet.*/
    stadtplanY = ( ((double)(FENSTERMAX_J-j) / FENSTERMAX_J) * (YMAX-YMIN) ) + YMIN;
    return stadtplanY;
  } /* Ende von berechneBildschirmI */


  /* *******************************************************
   * Hier beginnt der kryptische Teil vom Java-Programm. Den Teil brauchst du nicht
   * zu verstehen. Sogar Profis haben Mhe, immer genau den berblick zu behalten.
   */

  public Graphics zeichnungsBrett;
  public Image zeichnungsBrettBild;
  private Thread thread;
  private boolean isRunning = false;

  public void init() {
    /* Wird zu Beginn (vom Appletviewer) aufgerufen, wenn das Applet gestartet wird.
     */
    thread = null;
    zeichnungsBrettBild = createImage(FENSTERMAX_I, FENSTERMAX_J);
    zeichnungsBrett = zeichnungsBrettBild.getGraphics();
  }

  public void start() {
    /* Kreiert einen neuen Thread, der nur fr unser hauptProgramm zustndig ist.
     * Der "alte" Thread bleibt auch aktiv, er sorgt dafr, dass das Gezeichnete
     * wenn ntig neu dargestllt wird.
     */
    if (thread == null) {
      thread = new Thread(this);
    }
    thread.start();
  }

  public void run() {
    /* Diese Methode wird durch thread.start(); ausgelst. Sie ruft unsere
     * Methode hauptProgramm() auf und beendet den Thread anschliessend.
     */
    isRunning = true;
    hauptProgramm(zeichnungsBrett);
    isRunning = false;
  }

  public void stop() {
    /* Wenn der Appletviewer beendet wird, so soll auch der Thread, der fr das
     * Neuzeichnen zustndig ist, beendet werden.
     */
    if ( (thread != null) && thread.isAlive() ) {
      thread.interrupt();
      thread = null;
      isRunning = false;
    }
  }

  public void zeichneZeichnungsBrettAufDenBildschirm(Graphics bildschirm) {
    bildschirm.drawImage(zeichnungsBrettBild, 0, 0, null);
  }

  public void update(Graphics bildschirm) {
    /* Wird vom der Methode repaint aufgerufen.
     * Wird keine update Methode deklariert, so wird der Bildschirm weiss gezeichnet
     * und anschliessend die Methode paint aufgerufen
     */
    zeichneZeichnungsBrettAufDenBildschirm(bildschirm);
  }

  public void paint(Graphics bildschirm) {
    /* zeichnet den Bildschirm neu, wenn ein anderes Fenster vorher einen Teil
     * verdeckt hat und nun dieses Fenster sich verndert hat.
     */
    zeichneZeichnungsBrettAufDenBildschirm(bildschirm);
  }

  public void schlafe(int schlafZeit) {
    /* legt das Programm eine gewisse Zeit schlafen. Die Zahl schlafZeit gibt die
     * Dauer des Schlafens in Millisekunden an. */
    try {
      if (isRunning) {
        repaint();
        Thread.sleep(schlafZeit);
      }
    }
    catch (InterruptedException e) {
      // Exception abfangen
    }
  }

}  /* Ende von Busplan */
